' Stack LIFO-Stack, der mit jedem String funktioniert.
' Man kann drauflegen und wegnehmen. An Stelle 1-4 im Mainstring liegt als CVDWD die Anzahl Elemente

#IF NOT %DEF(%D_LIFO_A_INC)
%D_LIFO_A_INC=1

'---------------------------------------------------------------------------------------------------
SUB D_AddTos_A(BYREF T01 AS STRING,BYREF T02 AS STRING)
 REGISTER T03 AS LONG
 IF LEN(T01)<5 THEN T01=CHR$(0,0,0,0)
 T01=T01+T02+MKDWD$(LEN(T02)) ' String=P1, Element=P2 (auch String) wird hinzugefgt.
 T03=CVDWD(T01)+1:MID$(T01,1,4)=MKDWD$(T03) ' Zhlung in Bytes 1-4 erhhen
END SUB
'---------------------------------------------------------------------------------------------------
MACRO FUNCTION D_GetLen_A(P9) = CVDWD(RIGHT$(P9,4))
'---------------------------------------------------------------------------------------------------
SUB D_RemLast_A(BYREF T01 AS STRING)
 REGISTER T03 AS LONG
 T03=CVDWD(T01,1)
 IF (T03>0) THEN
  DECR T03
  T01=LEFT$(T01,LEN(T01)-(D_GetLen_A(T01)+4)) ' Entfernt oberstes Stack-Element.
  MID$(T01,1,4)=MKDWD$(T03) ' Zhlung in Bytes 1-4 decremteniern
 END IF
END SUB
'---------------------------------------------------------------------------------------------------
FUNCTION D_GetTOS_A(BYREF T01 AS STRING) AS STRING
REGISTER T03 AS LONG,T04 AS DWORD
 T03=CVDWD(T01,1)
 IF (T03>0) THEN
   T04=D_GetLen_A(T01) ' Gibt oberstes Stack-Element zurck.
   FUNCTION=MID$(T01,LEN(T01)-(T04+3),T04)
 ELSE
   FUNCTION=""
 END IF
END FUNCTION
'---------------------------------------------------------------------------------------------------
FUNCTION D_GetRemTOS_A(BYREF T01 AS STRING) AS STRING
 LOCAL T02 AS STRING
     T02=D_GetTOS_A(T01)
     D_RemLast_A(T01) ' Gibt oberstes Stack-Element zurck und entfernt es.
 FUNCTION=T02
END FUNCTION
'---------------------------------------------------------------------------------------------------
MACRO D_Init_Stack_A(P1)
 P1=MKDWD$(0)
END MACRO
'---------------------------------------------------------------------------------------------------
FUNCTION D_GetAnz_A(BYREF T01 AS STRING) AS DWORD
  REGISTER T02 AS DWORD
  if_ZL(T01)  T02=0: GOTO enx
  T02=CVDWD(T01)
  enx:
  FUNCTION=T02
END FUNCTION
'---------------------------------------------------------------------------------------------------
#ENDIF
